if db_id('master') is not null and object_id('master.dbo.GetSqlDetail','P') is not null
begin
  set nocount on
  execute ('execute master.dbo.GetSqlDetail')
end
else
begin
	if(cast(cast(SERVERPROPERTY('ProductVersion') as char(2)) as decimal) < 11)
	begin
		if(cast(cast(SERVERPROPERTY('ProductVersion') as char(2)) as decimal) > 9)
		begin
			exec('SELECT @@VERSION as [Version],
			(select filename from master..sysfiles where fileid=1) as [Master],
			(select filename from master..sysfiles where fileid=2) as [MastLog], 
			cast(serverproperty(''ErrorLogFileName'') as sysname) as [ErrorLog],
			cast(cast(physical_memory_in_bytes/1048576.0 as money) as varchar) as [Physical_Memory_MB],
			cast(cast([available_physical_memory_kb]/1024.0 as money) as varchar) as [Available_Memory_MB],
			cast(cast((bpool_committed*8)/1024.0 as money) as varchar) as [BPool_Committed_MB],
			cast(cast([physical_memory_in_use_kb]/1024.0 as money) as varchar) as [Physical_Memory_in_Use_MB],
			cast(cast([max_server_memory] as money) as varchar) AS [Max_Server_Memory_MB],
			cast(cast([min_server_memory] as money) as varchar) AS [Min_Server_Memory_MB]     
			FROM sys.dm_os_sys_info,sys.dm_os_process_memory,sys.dm_os_sys_memory
			CROSS JOIN (SELECT [value_in_use] AS [max_server_memory] FROM sys.configurations WHERE [name] = ''max server memory (MB)'') AS c
			CROSS JOIN (SELECT [value_in_use] AS [min_server_memory] FROM sys.configurations WHERE [name] = ''min server memory (MB)'') AS c2
			 ')
		end
		else /*sql2k5*/
		begin
			exec('SELECT @@VERSION as [Version],
			(select filename from master..sysfiles where fileid=1) as [Master],
			(select filename from master..sysfiles where fileid=2) as [MastLog],
			cast(cast(physical_memory_in_bytes/1048576.0 as money) as varchar) as [Physical_Memory_MB],
			cast(cast(virtual_memory_in_bytes/1048576.0 as money) as varchar) as [Virtual_Memory_MB],
			cast(cast((bpool_committed*8)/1024.0 as money) as varchar) as [BPool_Committed_MB],
			(SELECT cast(cast(cntr_value/1024.0 as money) as varchar) 
			FROM sys.dm_os_performance_counters 
			WHERE counter_name = ''Total Server Memory (KB)'') as [Total_Server_Memory_MB]
			FROM sys.dm_os_sys_info')
		end
	end
	else /*sql2k12*/
	begin
		exec('SELECT @@VERSION as [Version],
		(select filename from master..sysfiles where fileid=1) as [Master],
		(select filename from master..sysfiles where fileid=2) as [MastLog],
		cast(serverproperty(''ErrorLogFileName'') as sysname) as [ErrorLog], 
		cast(cast([physical_memory_kb]/1024.0 as money) as varchar) as [Physical_Memory_MB],
		(select cast(cast([available_physical_memory_kb]/1024.0 as money) as varchar) from sys.dm_os_sys_memory)as [Available_Memory_MB],
		cast(cast([committed_kb]/1024.0 as money) as varchar) as [BPool_Committed_MB],
		cast(cast([physical_memory_in_use_kb]/1024.0 as money) as varchar) as [Physical_Memory_in_Use_MB],
		cast(cast([max_server_memory] as money) as varchar) AS [Max_Server_Memory_MB],
		cast(cast([min_server_memory] as money) as varchar) AS [Min_Server_Memory_MB]    
		FROM sys.dm_os_sys_info,sys.dm_os_process_memory
		CROSS JOIN (SELECT [value_in_use] AS [max_server_memory] FROM sys.configurations WHERE [name] = ''max server memory (MB)'') AS c
		CROSS JOIN (SELECT [value_in_use] AS [min_server_memory] FROM sys.configurations WHERE [name] = ''min server memory (MB)'') AS c2
		 ')
	end
end