﻿/*
 * DH2i custom javascripts
 * 
 */

window.encryptAES = async (message, key, iv) =>{

    var input_bytes = CryptoJS.enc.Utf8.parse(message);
    var key_bytes = CryptoJS.enc.Base64.parse(key);
    var iv_bytes = CryptoJS.enc.Base64.parse(iv);

    var encrypted = CryptoJS.AES.encrypt(input_bytes, key_bytes,
        {
            iv: iv_bytes,
            asBytes: true,
            mode: CryptoJS.mode.CBC,
            blockSize: 256 / 32,
            padding: CryptoJS.pad.Pkcs7
        });
    return encrypted.toString(); //ciphertext.toString(CryptoJS.enc.Base64);
};


window.decryptAES= async (base64encrypted, key, iv) => {

    var key_bytes = CryptoJS.enc.Base64.parse(key);
    var iv_bytes = CryptoJS.enc.Base64.parse(iv);

    var decrypted = CryptoJS.AES.decrypt({ ciphertext: CryptoJS.enc.Base64.parse(base64encrypted) }, key_bytes, {
        iv: iv_bytes,
        asBytes: true,
        mode: CryptoJS.mode.CBC,
        blockSize: 256 / 32,
        padding: CryptoJS.pad.Pkcs7
    });
    return decrypted.toString(CryptoJS.enc.Utf8);
};

window.saveAsFile = async (filename, bytesBase64) => {
    var link = document.createElement('a');
    link.download = filename;
    link.href = "data:application/octet-stream;base64," + bytesBase64;
    document.body.appendChild(link); // Needed for Firefox
    link.click();
    document.body.removeChild(link);
};

navigator.permissions.query({ name: "clipboard-write" }).then(result => {
    if (result.state == "granted" || result.state == "prompt") {
        /* write to the clipboard now */
    }
});

function updateClipboard(newClip) {
    navigator.clipboard.writeText(newClip).then(function () {
        /* clipboard successfully set */
    }, function () {
        /* clipboard write failed */
    });
}

window.clipboardCopy = {
    copyText: function (text) {
        navigator.clipboard.writeText(text).then(function () {
        })
            .catch(function (error) {
                alert(error);
            });
    }
};

//window.executeCollapse = function (id, action) {
//    $('#'+id).collapse(action);
//};

//window.executeModal = function (id, action) {
//    $('#'+id).modal(action);
//};

window.executeCollapse = function (id, action) {
    ((bootstrap.Collapse.getOrCreateInstance(document.getElementById(id)))[action])();
};

window.executeModal = function (id, action) {
    ((bootstrap.Modal.getOrCreateInstance(document.getElementById(id)))[action])();
};