﻿// DH2i WebSocket interop module
window.dxcom_websocket = {
    socks: [],
    setup: function (dotnetobj, url) {
        var ws = new WebSocket(url);
        var rxbuf = null;
        ws.onopen = function (event) {
            dotnetobj.invokeMethodAsync('WebSocketStateChanged', 1, 0);
        };
        ws.onclose = function (event) {
            dotnetobj.invokeMethodAsync('WebSocketStateChanged', 2, event.code);
        };
        ws.onmessage = async function (event) {
            if (rxbuf === null || rxbuf.byteLength === 0) {
                var n = await dotnetobj.invokeMethodAsync('WebSocketGetRxBuffer');
                rxbuf = new Uint8Array(Module.HEAPU8.buffer, n[0], n[1]);
            }
            rxbuf.set(new Uint8Array(event.data));
            await dotnetobj.invokeMethodAsync('WebSocketMessage', event.data.byteLength);
        };
        ws.onerror = function (event) {
            dotnetobj.invokeMethodAsync('WebSocketStateChanged', 3, 0);
        };
        ws.binaryType = 'arraybuffer';
        var idx = this.socks.findIndex(x => x !== null);
        if (idx < 0) { idx = this.socks.push(ws) - 1; }
        else { this.socks[idx] = ws; }
        return idx;
    },
    send: function (idx, data) {
        return this.socks[idx].send(Blazor.platform.toUint8Array(data));
    },
    get_readystate: function (idx) {
        return this.socks[idx].readyState;
    },
    close: function (idx, code) {
        var ws = this.socks[idx];
        this.socks[idx].close(code);
        this.socks[idx] = null;
        ws.onopen = null; ws.onclose = null; ws.onmessage = null; ws.onerror = null; 
    }
};
window.append_elem_by_id = function (id, name, cls, content) {
    elem = document.createElement(name);
    elem.attributes.class = cls;
    elem.innerText = content;
    document.getElementById(id).appendChild(elem);
};
